SystemOrganization addCategory: #'JsonSeaside-Document'!
SystemOrganization addCategory: #'JsonSeaside-HTTP'!
SystemOrganization addCategory: #'JsonSeaside-RequestHandler'!
SystemOrganization addCategory: #'JsonSeaside-Libraries'!

!WAHtmlRenderer methodsFor: '*JsonSeaside' stamp: 'tonyg 8/23/2005 17:01'!
renderFragment: aUnaryBlock
	| renderer document stream |
	renderer := WAHtmlRenderer
					context: self context copy
					callbacks: self callbacks.
	stream := WriteStream on: String new.
	document := WAHtmlFragmentStreamDocument new stream: stream.
	renderer context document: document.
	aUnaryBlock value: renderer.
	document close.
	^ stream contents.
! !

!WAHtmlRenderer methodsFor: '*JsonSeaside' stamp: 'tonyg 8/23/2005 17:46'!
urlForJsonRequest: aUnaryBlock
	| arg result |
	^ WACurrentSession value actionUrlForContinuation:
		[:req |
		arg := Json readFrom: (req at: 'PUTData') readStream.
		result := aUnaryBlock value: arg.
		WACurrentSession value returnResponse:
			(WAResponse document: (Json render: result) mimeType: 'application/x-json')]
! !

WAHtmlStreamDocument subclass: #WAHtmlFragmentStreamDocument
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JsonSeaside-Document'!

!WAHtmlFragmentStreamDocument methodsFor: 'as yet unclassified' stamp: 'tonyg 8/23/2005 16:59'!
bodyStream
	"Override superclass implementation. We don't want the HTML root, just the contents of the body."
	^ stream! !

!WAHtmlFragmentStreamDocument methodsFor: 'as yet unclassified' stamp: 'tonyg 8/23/2005 16:59'!
close
	"Override superclass implementation. We don't want the close-tags for body and html."
! !

WAScriptLibrary subclass: #WAPushHookScripts
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JsonSeaside-Libraries'!

!WAPushHookScripts methodsFor: 'as yet unclassified' stamp: 'tonyg 8/17/2005 16:48'!
jsonJs
    ^ '
/*
Copyright (c) 2005 JSON.org

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The Software shall be used for Good, not Evil.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
SOFTWARE.
*/

Array.prototype.______array = ''______array'';

var JSON = {
    org: ''http://www.JSON.org'',
    copyright: ''(c)2005 JSON.org'',
    license: ''http://www.crockford.com/JSON/license.html'',

    stringify: function (arg) {
        var c, i, l, s = '''', v;

        switch (typeof arg) {
        case ''object'':
            if (arg) {
                if (arg.______array == ''______array'') {
                    for (i = 0; i < arg.length; ++i) {
                        v = this.stringify(arg[i]);
                        if (s) {
                            s += '','';
                        }
                        s += v;
                    }
                    return ''['' + s + '']'';
                } else if (typeof arg.toString !!= ''undefined'') {
                    for (i in arg) {
                        v = arg[i];
                        if (typeof v !!= ''undefined'' && typeof v !!= ''function'') {
                            v = this.stringify(v);
                            if (s) {
                                s += '','';
                            }
                            s += this.stringify(i) + '':'' + v;
                        }
                    }
                    return ''{'' + s + ''}'';
                }
            }
            return ''null'';
        case ''number'':
            return isFinite(arg) ? String(arg) : ''null'';
        case ''string'':
            l = arg.length;
            s = ''"'';
            for (i = 0; i < l; i += 1) {
                c = arg.charAt(i);
                if (c >= '' '') {
                    if (c == ''\\'' || c == ''"'') {
                        s += ''\\'';
                    }
                    s += c;
                } else {
                    switch (c) {
                        case ''\b'':
                            s += ''\\b'';
                            break;
                        case ''\f'':
                            s += ''\\f'';
                            break;
                        case ''\n'':
                            s += ''\\n'';
                            break;
                        case ''\r'':
                            s += ''\\r'';
                            break;
                        case ''\t'':
                            s += ''\\t'';
                            break;
                        default:
                            c = c.charCodeAt();
                            s += ''\\u00'' + Math.floor(c / 16).toString(16) +
                                (c % 16).toString(16);
                    }
                }
            }
            return s + ''"'';
        case ''boolean'':
            return String(arg);
        default:
            return ''null'';
        }
    },
    parse: function (text) {
        var at = 0;
        var ch = '' '';

        function error(m) {
            throw {
                name: ''JSONError'',
                message: m,
                at: at - 1,
                text: text
            };
        }

        function next() {
            ch = text.charAt(at);
            at += 1;
            return ch;
        }

        function white() {
            while (ch) {
                if (ch <= '' '') {
                    next();
                } else if (ch == ''/'') {
                    switch (next()) {
                        case ''/'':
                            while (next() && ch !!= ''\n'' && ch !!= ''\r'') {}
                            break;
                        case ''*'':
                            next();
                            for (;;) {
                                if (ch) {
                                    if (ch == ''*'') {
                                        if (next() == ''/'') {
                                            next();
                                            break;
                                        }
                                    } else {
                                        next();
                                    }
                                } else {
                                    error("Unterminated comment");
                                }
                            }
                            break;
                        default:
                            error("Syntax error");
                    }
                } else {
                    break;
                }
            }
        }

        function string() {
            var i, s = '''', t, u;

            if (ch == ''"'') {
outer:          while (next()) {
                    if (ch == ''"'') {
                        next();
                        return s;
                    } else if (ch == ''\\'') {
                        switch (next()) {
                        case ''b'':
                            s += ''\b'';
                            break;
                        case ''f'':
                            s += ''\f'';
                            break;
                        case ''n'':
                            s += ''\n'';
                            break;
                        case ''r'':
                            s += ''\r'';
                            break;
                        case ''t'':
                            s += ''\t'';
                            break;
                        case ''u'':
                            u = 0;
                            for (i = 0; i < 4; i += 1) {
                                t = parseInt(next(), 16);
                                if (!!isFinite(t)) {
                                    break outer;
                                }
                                u = u * 16 + t;
                            }
                            s += String.fromCharCode(u);
                            break;
                        default:
                            s += ch;
                        }
                    } else {
                        s += ch;
                    }
                }
            }
            error("Bad string");
        }

        function array() {
            var a = [];

            if (ch == ''['') {
                next();
                white();
                if (ch == '']'') {
                    next();
                    return a;
                }
                while (ch) {
                    a.push(value());
                    white();
                    if (ch == '']'') {
                        next();
                        return a;
                    } else if (ch !!= '','') {
                        break;
                    }
                    next();
                    white();
                }
            }
            error("Bad array");
        }

        function object() {
            var k, o = {};

            if (ch == ''{'') {
                next();
                white();
                if (ch == ''}'') {
                    next();
                    return o;
                }
                while (ch) {
                    k = string();
                    white();
                    if (ch !!= '':'') {
                        break;
                    }
                    next();
                    o[k] = value();
                    white();
                    if (ch == ''}'') {
                        next();
                        return o;
                    } else if (ch !!= '','') {
                        break;
                    }
                    next();
                    white();
                }
            }
            error("Bad object");
        }

        function number() {
            var n = '''', v;
            if (ch == ''-'') {
                n = ''-'';
                next();
            }
            while (ch >= ''0'' && ch <= ''9'') {
                n += ch;
                next();
            }
            if (ch == ''.'') {
                n += ''.'';
                while (next() && ch >= ''0'' && ch <= ''9'') {
                    n += ch;
                }
            }
            if (ch == ''e'' || ch == ''E'') {
                n += ''e'';
                next();
                if (ch == ''-'' || ch == ''+'') {
                    n += ch;
                    next();
                }
                while (ch >= ''0'' && ch <= ''9'') {
                    n += ch;
                    next();
                }
            }
            v = +n;
            if (!!isFinite(v)) {
                ////error("Bad number");
            } else {
                return v;
            }
        }

        function word() {
            switch (ch) {
                case ''t'':
                    if (next() == ''r'' && next() == ''u'' && next() == ''e'') {
                        next();
                        return true;
                    }
                    break;
                case ''f'':
                    if (next() == ''a'' && next() == ''l'' && next() == ''s'' &&
                            next() == ''e'') {
                        next();
                        return false;
                    }
                    break;
                case ''n'':
                    if (next() == ''u'' && next() == ''l'' && next() == ''l'') {
                        next();
                        return null;
                    }
                    break;
            }
            error("Syntax error");
        }

        function value() {
            white();
            switch (ch) {
                case ''{'':
                    return object();
                case ''['':
                    return array();
                case ''"'':
                    return string();
                case ''-'':
                    return number();
                default:
                    return ch >= ''0'' && ch <= ''9'' ? number() : word();
            }
        }

        return value();
    }
};
'
! !

!WAPushHookScripts methodsFor: 'as yet unclassified' stamp: 'tonyg 8/23/2005 17:48'!
pushHook
    ^ '
/*
Based on LivePage code from Seaside and numerous XMLHttpRequest tutorials on the web.
*/
function jsonAsyncRpc(uri, channels, arg, kont) {
    var request = false;

    if (window.XMLHttpRequest) {
        request = new XMLHttpRequest();
    } else {
        request = new ActiveXObject("Microsoft.XMLHTTP");
    }

    request.onreadystatechange = function () {
        if (request.readyState == 4) {
            if (kont !!= null)
                kont(JSON.parse(request.responseText));
        }
    }

    request.open("PUT", uri);
    request.setRequestHeader("Content-Type", "application/x-json");
    if (channels !!= null)
        request.setRequestHeader("X-WAPushHook-Channels", channels);
    request.send(JSON.stringify(arg));
}

function PushHook(uri) {
    this.hook = function(channels, arg, kont) {
        return jsonAsyncRpc(uri, channels, arg, kont);
    }
}
'
! !

Object subclass: #WAPushHook
	instanceVariableNames: 'request response ready'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JsonSeaside-HTTP'!

!WAPushHook methodsFor: 'initialize-release' stamp: 'tonyg 8/19/2005 15:44'!
initialize
	ready := Semaphore new.
! !

!WAPushHook methodsFor: 'as yet unclassified' stamp: 'tonyg 8/19/2005 14:41'!
reply: aResponse
	"A copy of the response is required, since we may send the same response to multiple requestors, and each transmission consumes some of the state of the response for some reason."
	response := aResponse copy.
	ready signal.! !

!WAPushHook methodsFor: 'accessing' stamp: 'tonyg 8/17/2005 08:10'!
request
	"Answer the value of request"

	^ request! !

!WAPushHook methodsFor: 'accessing' stamp: 'tonyg 8/17/2005 08:10'!
request: anObject
	"Set the value of request"

	request _ anObject! !

!WAPushHook methodsFor: 'accessing' stamp: 'tonyg 8/17/2005 08:10'!
response
	"Answer the value of response"

	^ response! !

!WAPushHook methodsFor: 'as yet unclassified' stamp: 'tonyg 8/17/2005 08:25'!
waitForReply
	[response isNil] whileTrue: [ready wait].! !

WAEntryPoint subclass: #WAPushHookHandler
	instanceVariableNames: 'channels mutex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JsonSeaside-RequestHandler'!

!WAPushHookHandler commentStamp: 'tonyg 8/17/2005 08:06' prior: 0!
I accept URLs containing a parameter called 'channels', containing a comma-separated list of channel names which I use to hook the request into my 'channels' instance variable. I do not reply immediately - I wait for a WAResponse to be sent from another thread via broadcast:toChannel:.!

!WAPushHookHandler class methodsFor: 'as yet unclassified' stamp: 'tonyg 8/17/2005 07:58'!
description
	^ 'Push Hook Handler'! !

!WAPushHookHandler methodsFor: 'as yet unclassified' stamp: 'tonyg 8/19/2005 14:55'!
addHook: hook channels: hooks
	| chan |
	mutex critical: [
		hooks do: [:hookName|
			chan := channels at: hookName
							ifAbsent: [channels at: hookName put: IdentitySet new].
			chan add: hook.]].
! !

!WAPushHookHandler methodsFor: 'as yet unclassified' stamp: 'tonyg 8/17/2005 08:36'!
broadcast: aResponse toChannel: chanName
	(self channelNamed: chanName) do: [:hook | hook reply: aResponse].! !

!WAPushHookHandler methodsFor: 'as yet unclassified' stamp: 'tonyg 8/17/2005 08:35'!
channelNamed: aString
	^ (channels at: aString ifAbsent: [IdentitySet new]) copy.! !

!WAPushHookHandler methodsFor: 'as yet unclassified' stamp: 'tonyg 8/19/2005 15:44'!
handleRequest: aRequest
	| hooks hook |

	hooks := self requestedChannelNames: aRequest.
	hooks ifEmpty: [^ WAResponse internalError: 'No channels given'].
	
	hook := WAPushHook new.
	hook request: aRequest.
	self addHook: hook channels: hooks.
	hook waitForReply.
	self removeHook: hook channels: hooks.
	^ hook response.! !

!WAPushHookHandler methodsFor: 'as yet unclassified' stamp: 'tonyg 8/17/2005 07:57'!
initialize
	mutex _ Semaphore forMutualExclusion.
	channels _ Dictionary new.! !

!WAPushHookHandler methodsFor: 'as yet unclassified' stamp: 'tonyg 8/19/2005 14:57'!
removeHook: hook channels: hooks
	mutex critical: [
		hooks do: [:hookName|
			channels at: hookName
					ifPresent: [:ch | ch remove: hook ifAbsent: [].
						ch ifEmpty: [channels removeKey: hookName]]]].
! !

!WAPushHookHandler methodsFor: 'as yet unclassified' stamp: 'tonyg 8/19/2005 14:54'!
requestedChannelNames: aRequest
	^ (aRequest at: 'channels'
				ifAbsent: [ (aRequest headerAt: 'x-wapushhook-channels') ifNil: [''] ])
			findTokens: ','.
! !
